import { SqlTaggedTemplateType } from 'slonik';
import { PostgresConfig, QueryCallback } from './types';
export declare class Postgres {
    private _pool;
    private _logger;
    sql: SqlTaggedTemplateType;
    constructor(config: PostgresConfig);
    any<T = any>(query: QueryCallback<T>): Promise<T[]>;
    anyFirst<T = any>(query: QueryCallback<T>): Promise<T[keyof T][]>;
    many<T = any>(query: QueryCallback<T>): Promise<T[]>;
    manyFirst<T = any>(query: QueryCallback<T>): Promise<T[keyof T][]>;
    maybeOne<T = any>(query: QueryCallback<T>): Promise<T | null>;
    transaction(queries: QueryCallback<any>[]): Promise<void>;
    maybeOneFirst<T = any>(query: QueryCallback<T>): Promise<T[keyof T] | null>;
    one<T = any>(query: QueryCallback<T>): Promise<T>;
    oneFirst<T = any>(query: QueryCallback<T>): Promise<T[keyof T]>;
    query<T = any>(query: QueryCallback<T>): Promise<import("slonik").QueryResultType<T>>;
    cursor<T = any>(rows: number, query: QueryCallback<T>): Promise<import("./types").CursorReaderResult<T>>;
}
