import { SqlTaggedTemplateType, SqlSqlTokenType } from 'slonik';
import { QueryResult } from 'pg';
export { SqlTaggedTemplateType, QueryResult };
export declare type Logger = {
    error: (...data: any[]) => void;
    info: (...data: any[]) => void;
};
export declare type CursorResult<T> = {
    result: {
        rowCount: number;
        rows: T[];
    };
};
export declare type CursorControls<T> = {
    next: () => Promise<CursorReaderResult<T>>;
    close: () => void;
};
export declare type CursorReaderResult<T> = (CursorControls<T> & CursorResult<T>) | CursorResult<T>;
export declare type QueryCallback<T> = (query: SqlTaggedTemplateType) => SqlSqlTokenType<T>;
export declare type PostgresConfig = {
    database: string;
    host: string;
    port: number;
    user: string;
    password: string;
    migrations?: string;
    logger?: Logger;
    idleTimeoutMillis?: number;
    captureStackTrace?: boolean;
    connectionRetryLimit?: number;
    connectionTimeout?: number | 'DISABLE_TIMEOUT';
    idleInTransactionSessionTimeout?: number | 'DISABLE_TIMEOUT';
    statementTimeout?: number | 'DISABLE_TIMEOUT';
    maximumPoolSize?: number;
    onReady?: () => void;
};
