import { SqlSqlTokenType } from 'slonik';
import { CursorReaderResult, PostgresConfig, Logger } from './types';
export declare function initialize(conf: Pick<PostgresConfig, 'host' | 'port' | 'user' | 'password' | 'database' | 'migrations' | 'logger' | 'onReady'>): Promise<undefined>;
export declare function readCursor<T = any>(rows: number, cursor: any): Promise<CursorReaderResult<T>>;
export declare function handleQuery<E, T>(queryMethod: (q: SqlSqlTokenType<T>) => Promise<E>, query: SqlSqlTokenType<T>, logger: Logger): Promise<E>;
export declare const defaultLogger: {
    info: (...args: any[]) => void;
    error: (...args: any[]) => void;
};
